jQuery(document).ready(function($) {
	wpcc_url 			= $('.wpcc_url').val();
	wpcc_data 			= {};
	wpcc_data_field 	= {};	
	
	function wpcc_fn_action(value, fid, wpcc_id) {
		/* JQ Field Copy  */	
		$('.wpcc_jq_copy').each(function() {
			var get_id	= $(this).data('get_id');
			var this_fid = $(this).data('fid');
			if(get_id == fid)
			{
				$(this).val(value);
				wpcc_data_field[this_fid] = value;
			}
		});
		/* JQ IF */
		$('.wpcc_jq_if').each(function() {
			var if_id 			= $(this).data('if_id');
			var if_operator 	= $(this).data('operator');
			var if_val 			= String($(this).data('val'));
			var if_show_id		= $(this).data('show');
			var if_hide_id		= $(this).data('hide');
			var if_logic		= $(this).data('logic');
			if(if_id == fid)
			{
				wpcc_jq_if_check_condition(value, if_val, if_operator, if_show_id, if_hide_id, if_logic, wpcc_id);
			}
		});
		/* Result Fields */
		$('.wpcc_result_fields').each(function() {
			var this_action = $(this).data('action');
			var this_fileds = String($(this).data('fileds'));
			var this_fid 	= $(this).data('fid');
			if(this_fileds.length > 0) {
				var fileds_arr	= this_fileds.indexOf(",");
				if(fileds_arr >= '0')
				{
					var fileds_split = this_fileds.split(",");
					var rf_out = []; 
					for (i = 0; i < fileds_split.length; i++ ) {
						var type = $('.wpcc_jq_action_'+fileds_split[i]).data('type');
						if(type == 'inputtext')
						{
							var rf_val = wpcc_data[wpcc_id][fileds_split[i]+'_res'];
						}
						else
						{
							var rf_val = wpcc_data[wpcc_id][fileds_split[i]];
						}
						rf_out.push(rf_val);
					}
					$.post(
					wpcc_url + '/action/wpcc_sum.php', { s : rf_out.join(this_action) },
						function(res){
							$('.wpcc_result_fields').val(res);
							wpcc_data_field[this_fid] = res;
						}
					);
				}
			}
		});
		//console.log(wpcc_data);
	}
	
	/* Fields Action */
	$.fn.wpcc_field_action = function() {
		$(this).each(function() {
			var this_form 		= $(this).closest('.wpcc_form');
			var wpcc_id 		= $('.wpcc_id', this_form).val();
			var type 			= $(this).data('type');
			var fid 			= $(this).data('fid');
			var field_value 	= '';
			wpcc_data[wpcc_id] 	= {};
			/* Load Default Data */
			if( type == 'checkbox' || type == 'slider' || type == 'session' || type == 'jquery' || type == 'result_fields')
			{
				wpcc_data_field[fid] = $(this).data('default');
			}
			else if(type == 'inputtext')
			{
				wpcc_data_field[fid] = $(this).data('default');
				var this_action		= $(this).data('action');
				var this_price		= $(this).data('price');
				var this_default	= $(this).data('default')
				$.post(
				wpcc_url + '/action/wpcc_sum.php', { s : this_default+this_action+this_price },
					function(res){
						wpcc_data_field[fid+'_res'] = res;
					}
				);
			}
			else if(type == 'hidden')
			{
				wpcc_data_field[fid] = $(this).val();
			}
			else if(type == 'select')
			{
				wpcc_data_field[fid] = $(':selected', this).val();
			}
			else if(type == 'radio')
			{
				if($(this).prop("checked"))
				{
					wpcc_data_field[fid] = $(this).val();
				}
			}
			
			/* Action */
			if(type == 'inputtext')
			{		
				$(this).keyup( function()
				{
					var field_value = $(this).val();
					wpcc_data_field[fid] = field_value;
					
					if(field_value == '')
					{
						field_val_res =  $(this).data('default');
					}
					else
					{
						field_val_res = field_value;
					}
					var this_action		= $(this).data('action');
					var this_price		= $(this).data('price');
					$.post(
					wpcc_url + '/action/wpcc_sum.php', { s : field_val_res+this_action+this_price },
						function(res){
							wpcc_data_field[fid+'_res'] = res;
							wpcc_fn_action(field_value, fid, wpcc_id);
						}
					);
				});
			}
			else if(type == 'select')
			{
				$(this).change( function()
				{
					var field_value = $(this).val();
					wpcc_data_field[fid] = field_value;
					wpcc_fn_action(field_value, fid, wpcc_id);
				});
			}
			else if(type == 'radio')
			{
				$(this).click( function()
				{
					var field_value = $(this).val();
					wpcc_data_field[fid] = field_value;
					wpcc_fn_action(field_value, fid, wpcc_id);
				});
			}
			else if(type == 'checkbox')
			{
				var this_action = $(this).data('action');
				var this_prop 	= {};
				$('input', $(this)).each(function()
				{
					$(this).click( function()
					{
						if($(this).prop("checked"))
						{
							this_prop[$(this).data('i')] = $(this).val();
						}
						else
						{
							delete this_prop[$(this).data('i')];
						}
						var this_out = []; 
						for (var this_key in this_prop) {
							this_out.push(this_prop[this_key]); 
						}
						$.post(
						wpcc_url + '/action/wpcc_sum.php', { s : this_out.join(this_action) },
							function(res){
								var field_value = res;
								wpcc_data_field[fid] = field_value;
								wpcc_fn_action(field_value, fid, wpcc_id);
							}
						);
					});
				});
				
			}
			else if(type == 'slider')
			{
				/* view fn.wpcc_slider callback STOP */
			}
			wpcc_data[wpcc_id] = wpcc_data_field;
		});
	};
	$('.wpcc_jq_action').wpcc_field_action();
	
	/* If Change */
	$.fn.wpcc_jq_if_change = function(ids, fn, wpcc_id) {
		ids_string = String(ids);
		if(ids_string.length > 0) {
			var this_check_arr_show	= ids_string.indexOf(",");
			
			if(this_check_arr_show >= '0')
			{
				var this_show_arr 	= ids_string.split(",");
				for (i = 0; i < this_show_arr.length; i++ ) {
					if(fn == 'show')
					{
						$('.wpcc_' + wpcc_id + ' .wpcc_box_' + this_show_arr[i]).show();
					}
					else if(fn == 'hide')
					{
						$('.wpcc_' + wpcc_id + ' .wpcc_box_' + this_show_arr[i]).hide();
					}
				}
			}
			else
			{
				if(fn == 'show')
				{
					$('.wpcc_' + wpcc_id + ' .wpcc_box_' + ids_string).show();
				}
				else if(fn == 'hide')
				{
					$('.wpcc_' + wpcc_id + ' .wpcc_box_' + ids_string).hide();
				}
			}
		}
	};
	
	/* Сondition */
	function wpcc_jq_if_check_condition (value, if_val, operator, s, h, if_logic, wpcc_id) {
		var this_type = $(this).data('type');
		
		if(this_type == 'checkbox')
		{
			var for_checked = $(this).prop("checked");
		}
		else
		{
			var for_checked = true;
		}
		if(operator != '==' && operator != 'between')
		{
			var value 	= value - 0;
			var if_val 	= if_val - 0;
		}
		
		if(operator == 'between')
		{
			var if_value_between 		= if_val.split("-");
			var if_value_between_one 	= if_value_between[0];
			var if_value_between_two 	= if_value_between[1];
			var value 					= value - 0;
		}
		if(
			( operator == '==' && ( for_checked && value == if_val ) )
			||
			( operator == '>=' && ( for_checked && value >= if_val ) )
			||
			( operator == '<=' && ( for_checked && value <= if_val ) )
			||
			( operator == '>' && ( for_checked && value > if_val ) )
			||
			( operator == '<' && ( for_checked && value < if_val ) )
			||
			( operator == 'between' && ( for_checked && value >= if_value_between_one && value <= if_value_between_two ) )
		)
		{
			$(this).wpcc_jq_if_change(s, 'show', wpcc_id);
			$(this).wpcc_jq_if_change(h, 'hide', wpcc_id);
		}
		else
		{
			if(if_logic != 'if')
			{
				$(this).wpcc_jq_if_change(s, 'hide', wpcc_id);
				$(this).wpcc_jq_if_change(h, 'show', wpcc_id);
			}
		}
	}
	
	/* Slider */
	$.fn.wpcc_slider = function () {
		$(this).each(function() {
			var this_sl  	= $(this);
			var this_parent	= this_sl.closest('.wpcc_box');
			var this_form 	= this_sl.closest('.wpcc_form');
			var wpcc_id 	= $('.wpcc_id', this_form).val();
			
			var fid   = this_sl.data('fid');
			var sl_va = $(this).data('value');
			var sl_mi = $(this).data('min');
			var sl_ma = $(this).data('max');
			var sl_st = $(this).data('step');
			var sl_po = $(this).data('position');
			this_sl.slider({
				orientation: 	sl_po,
				range: 			'min',
				value: 			sl_va,
				min: 			sl_mi,
				max: 			sl_ma,
				step: 			sl_st,
				slide:	function( event, ui ) {
					$( '.wpcc_jq_slider_text', this_parent ).val( ui.value );
				},
				stop:	function( event, ui ) {
					wpcc_data_field[fid] = ui.value;
					wpcc_data[wpcc_id] = wpcc_data_field;
					wpcc_fn_action(ui.value, fid, wpcc_id);
				}
			});
			$( '.wpcc_jq_slider_text', this_parent ).keyup( function() {
				if($(this).val() < sl_mi)
				{
					var input_slider_val = sl_mi;
				}
				else if($(this).val() > sl_ma)
				{
					var input_slider_val = sl_ma;
				}
				else
				{
					var input_slider_val = $(this).val();
				}
				$('.wpcc_jq_slider_box', this_parent).slider( "value", input_slider_val );
				$(this).val(input_slider_val);
				wpcc_data_field[fid] = input_slider_val;
				wpcc_data[wpcc_id] = wpcc_data_field;
				wpcc_fn_action(input_slider_val, fid, wpcc_id);
			});
		});
	}
	$('.wpcc_jq_slider').wpcc_slider();
	
	/* WPCC Validation */
		/* Only Numbers */
		$.fn.wpcc_v_o_n = function () {
			$(this).each(function() {
				$(this).live("keyup keydown click", function() {
					if ( this.value.match( /[^0-9.]/g ) )
					{
						this.value = this.value.replace( ',', '.' );
						this.value = this.value.replace( /[^0-9.]/g, '' );
					}
				});
			});
		};
		$('.wpcc_jq_validation_only_numbers').wpcc_v_o_n();
	
	/* Send Calc */
	$('.wpcc_form .wpcc_submit').live('click', function() {
		var wpcc_this_p = $(this).closest('form');
		var wpcc_id 	= $('.wpcc_id', wpcc_this_p).val();
		var wpcc_autos 	= $('.wpcc_id', wpcc_this_p).data('autoscroll');
		
		$('.wpcc_loading div', wpcc_this_p).show();
		$.post(
			wpcc_url + '/action/wpcc_result.php',
			wpcc_this_p.serialize(),
			function(data){
				$('.wpcc_result_block_' + wpcc_id).html(data);
				$('.wpcc_loading div', wpcc_this_p).hide();
				if(wpcc_autos == 'y')
				{
					$('html,body').animate({
						scrollTop: $('.wpcc_result_block_' + wpcc_id).offset().top
					}, 800);
				}
			}
		);
		return false;
	});
	
	/* Send Mail */
	$('.wpcc_mail .wpcc_submit').live('click', function() {
		var wpcc_this_p = $(this).closest('form');
		var wpcc_id 	= $('.wpcc_id', wpcc_this_p).val();
		
		$('.wpcc_loading div', wpcc_this_p).show();
		$.post(
			wpcc_url + '/action/wpcc_mail.php',
			wpcc_this_p.serialize(),
			function(data){
				$('.wpcc_result_block_' + wpcc_id).html(data);
				$('.wpcc_loading div', wpcc_this_p).hide();
			}
		);
		return false;
	});
	
});